package com.agiledeveloper;

import java.util.Arrays;
import java.util.function.Consumer;

public class Sample {
  //Compile, take a look at the bytecode using javap -c,
  //and examine play1, play2, and play3.

  public void play1() {
    Arrays.asList(1, 2, 3).forEach(new Consumer<Integer>() {
      @Override
      public void accept(Integer value) {
        System.out.println(value);
      }
    });
  }

  public void play2() {
    Arrays.asList(1, 2, 3).forEach(value -> System.out.println(value));
  }

  public void play3() {
    Arrays.asList(1, 2, 3).forEach(System.out::println);
  }

  public static void main(String[] args) {
    Sample sample = new Sample();
    sample.play1();
    sample.play2();
    sample.play3();
  }
}
